#define _CRT_SECURE_NO_WARNINGS

#include <direct.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <fstream>

#include "ls11_lib.h"

using namespace std;


int ls11_EncodePack(char *szOutputFileName, char *szInputPattern, vector<vector<byte>> *pvecSrcDataArray, vector<byte> *pDstLS11PackedData) {

	ls11_out_loc_data_list.clear();
	vPackOutDataArray.clear();

	// oôꂼ̖O
	char szCurFileName[256] = "";

	// t@CTB
	for ( int iNo=0; iNo<3000; iNo++ ) {
		sprintf_s(szCurFileName, "%s/%s.%03d", szInputPattern, szInputPattern, iNo );

		int iTargetFileSize=0;
		int iKeepableMemSize=0;
		int iInputFileSize=0;
		int iOutputFileSize=0;
		char *inData=NULL;
		char *outData=NULL;
		/*
		printf("̓t@C:");
		scanf("%s",input);
		printf("o̓t@C:");
		scanf("%s",output);
		*/
		// t@C̏ꍇ
		if ( !pvecSrcDataArray && szInputPattern )  {
			/* t@CTCY擾 */
			iInputFileSize = ls11_getFileSize(szCurFileName);
			if(iInputFileSize < 0){
				//fflush(stdin);
				// t@CIB
				break;
			}
			inData = (char *)calloc(iInputFileSize , sizeof(char));
			if(inData == NULL ){
				//printf("̈擾G[\n");
				//fflush(stdin); 
				return -1;
			}
			iInputFileSize = ls11_getFileData(szCurFileName, inData, iInputFileSize);
			if(iInputFileSize < 0){
				free(inData);
				//fflush(stdin);
				return -1;
			}
			// Vectoȑꍇ
		} else if (pvecSrcDataArray) {
			if ( iNo >= (int)(*pvecSrcDataArray).size() ) { break; }
			iInputFileSize = (*pvecSrcDataArray)[iNo].size();
			inData = (char *)calloc(iInputFileSize , sizeof(char));
			memcpy(inData, (char *)&(*pvecSrcDataArray)[iNo][0], iInputFileSize);
		} else {
			return -1;
		}

		iKeepableMemSize = iInputFileSize * 5;
		outData = (char *)calloc(iKeepableMemSize, sizeof(char));
		if(outData == NULL ){
			free(inData);
			//printf("̈擾G[\n");
			//fflush(stdin); 
			return -1;
		}

		iOutputFileSize = ls11_Encode(inData, iInputFileSize, outData, iKeepableMemSize);
		free(inData); // malloc

		if(iOutputFileSize < 0){
			// printf("GR[hs:%d\n",fsize3);
			free(outData);
			//fflush(stdin); 
			return -1;
		}
		// wb_[Rs[(͂́At@CςĂŒI)
		memcpy( &ls11_out_pack_header.header, outData, sizeof(ls11_out_pack_header.header));

		// P[V̕Rs[(AfBV)
		LS11LOCATIONDATA *p_cur_loc_data = (LS11LOCATIONDATA *)(char *)(outData+0x110);
		// ͂߂ĂȂ΁Â܂ܑB
		ls11_out_loc_data_list.push_back( *p_cur_loc_data );

		// f[^CɃRs[
		vector<byte> vCurLS11Buf(&outData[0x120], &outData[iOutputFileSize]);
		vPackOutDataArray.push_back(vCurLS11Buf);

		// pς񂾂̂ŉB̃pbNt@C
		free(outData);
	}

	// Ō ls11_out_loc_data_list ̈ԍŏ̃AhXԈĂ̂ŁAŏ̃AhXCAɊÂđSẴAhXCKvB
	for ( int loc=0; loc < (int)ls11_out_loc_data_list.size(); loc++ ) {
		if ( loc==0 ) {
			ls11_out_loc_data_list[0].iStartAddress = ls11_ChangeEndian(0x110 + 12*ls11_out_loc_data_list.size() + 4); // ̃P[Vf[^pbNĂ̂ŁA1ڂ̈ʒuωB
		} else {
			// PÕAhX{PO̒
			// f[^rbOGfBAȂ̂ŁAgGfBAɂāAvZB
			int iStartAddress = ls11_ChangeEndian(ls11_out_loc_data_list[loc-1].iStartAddress) + ls11_ChangeEndian(ls11_out_loc_data_list[loc-1].iDataLenSize);
			// gGfBArbOGfBAɖ߂
			iStartAddress = ls11_ChangeEndian( iStartAddress );
			ls11_out_loc_data_list[loc].iStartAddress = iStartAddress;
		}
	}

	if ( pDstLS11PackedData ) {
		// ꎞobt@ǂ̂炢mۂ̂vZ
		char *tmpBuf = NULL;
		int iCntBufSize = 0;
		for (int loc=0; loc<(int)ls11_out_loc_data_list.size(); loc++ ) {
			iCntBufSize += 12;
		}
		for (int buf=0; buf<(int)vPackOutDataArray.size(); buf++ ) {
			iCntBufSize += vPackOutDataArray[buf].size();
		}
		tmpBuf = (char *)calloc(iCntBufSize+1000, sizeof(char));

		char *pTmpBuf = tmpBuf;

		// wb_[{
		memcpy( pTmpBuf, (char *)ls11_out_pack_header.header, sizeof(ls11_out_pack_header.header) );
		pTmpBuf += sizeof(ls11_out_pack_header.header);

		// P[V֘A
		for (int loc=0; loc<(int)ls11_out_loc_data_list.size(); loc++ ) {
			memcpy( pTmpBuf, (char *)(char *)&ls11_out_loc_data_list[loc].iDataLenSize, 12 );
			pTmpBuf += 12;
		}
		// P[VÎO݁BSoCg(int P)
		int iEnd = 0;
		memcpy( pTmpBuf, (char *)&iEnd, 4 );
		pTmpBuf += 4;

		// f[^
		for (int buf=0; buf<(int)vPackOutDataArray.size(); buf++ ) {
			memcpy( pTmpBuf, (char *)&vPackOutDataArray[buf][0], vPackOutDataArray[buf].size() );
			pTmpBuf += vPackOutDataArray[buf].size();
		}

		// nꂽpDstLS11PackedDataɔf
		int cpysize =  (int)pTmpBuf-(int)tmpBuf;
		(*pDstLS11PackedData).resize( cpysize );
		memcpy( (char *)&(*pDstLS11PackedData)[0], tmpBuf, cpysize );

		// ꎞobt@̉
		free(tmpBuf);
	}

	if ( szOutputFileName ) {

		// oCiŃI[v
		FILE *fp = fopen(szOutputFileName, "wb");

		// wb_[{
		fwrite( (char *)ls11_out_pack_header.header, sizeof(ls11_out_pack_header.header), 1, fp);

		// P[V֘A
		for (int loc=0; loc<(int)ls11_out_loc_data_list.size(); loc++ ) {
			fwrite( (char *)&ls11_out_loc_data_list[loc].iDataLenSize, 12, 1, fp);
		}
		// P[VÎO݁BSoCg(int P)
		int iEnd = 0;
		fwrite( (char *)&iEnd, 4, 1, fp );

		// f[^
		for (int buf=0; buf<(int)vPackOutDataArray.size(); buf++ ) {
			fwrite( (char *)&vPackOutDataArray[buf][0], vPackOutDataArray[buf].size(), 1, fp );
		}
		fclose(fp);
	}

	return 0;
}


